import React from 'react';
import PropTypes from 'prop-types';
import Step from "semantic-ui-react/dist/es/elements/Step/Step.js";
import Icon from "semantic-ui-react/dist/es/elements/Icon/Icon.js";

var WizardNav = function WizardNav(_ref) {
  var stepsInfo = _ref.stepsInfo,
      activeStepIndex = _ref.activeStepIndex;
  return /*#__PURE__*/React.createElement(Step.Group, null, stepsInfo.map(function (_ref2, idx) {
    var title = _ref2.title,
        description = _ref2.description,
        icon = _ref2.icon;
    return /*#__PURE__*/React.createElement(Step, {
      key: idx,
      active: activeStepIndex === idx
    }, icon && /*#__PURE__*/React.createElement(Icon, {
      name: icon
    }), /*#__PURE__*/React.createElement(Step.Content, null, /*#__PURE__*/React.createElement(Step.Title, null, title), description && /*#__PURE__*/React.createElement(Step.Description, null, description)));
  }));
};

WizardNav.propTypes = {
  stepsInfo: PropTypes.arrayOf(PropTypes.shape({
    title: PropTypes.node,
    label: PropTypes.node,
    StepLabelProps: PropTypes.object,
    StepProps: PropTypes.object
  })),
  activeStepIndex: PropTypes.number
};
export default WizardNav;