"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.reducer = exports["default"] = void 0;

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _isEqual = _interopRequireDefault(require("lodash/isEqual"));

var _useFormApi2 = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/use-form-api"));

var _fieldArray = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/field-array"));

var _Button = _interopRequireDefault(require("semantic-ui-react/dist/commonjs/elements/Button/Button.js"));

var _Header = _interopRequireDefault(require("semantic-ui-react/dist/commonjs/elements/Header/Header.js"));

var _ButtonGroup = _interopRequireDefault(require("semantic-ui-react/dist/commonjs/elements/Button/ButtonGroup.js"));

var _useFieldApi2 = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/use-field-api"));

var _reactJssCjs = require("react-jss/dist/react-jss.cjs.js");

var _clsx2 = _interopRequireDefault(require("clsx"));

var _formField = _interopRequireDefault(require("../form-field/form-field"));

var _excluded = ["className"],
    _excluded2 = ["remove"],
    _excluded3 = ["remove"],
    _excluded4 = ["className"],
    _excluded5 = ["className"],
    _excluded6 = ["className"],
    _excluded7 = ["className"],
    _excluded8 = ["className"],
    _excluded9 = ["arrayValidator", "label", "description", "fields", "defaultItem", "meta", "minItems", "maxItems", "noItemsMessage", "buttonLabels", "FieldArrayGridProps", "FieldArrayHeaderProps", "FieldArrayButtonGridProps", "ButtonGroupProps", "UndoButtonProps", "RedoButtonProps", "AddButtonProps", "DescriptionProps", "ArrayItemsGridProps", "NoItemsProps", "RemoveButtonProps", "ArrayItemGridProps", "ArrayItemFieldsGridProps"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var useStyles = (0, _reactJssCjs.createUseStyles)({
  buttonGroup: {
    display: 'flex',
    justifyContent: 'flex-end'
  },
  arrayItem: {
    marginBottom: '1em'
  },
  arrayItems: {
    marginTop: '1em'
  },
  error: {
    color: '#9f3a38 !important'
  },
  noItems: {
    paddingBottom: '1em'
  },
  noMargin: {
    margin: '0 !important'
  },
  arrayHeader: {
    display: 'flex',
    justifyContent: 'space-between',
    alignItems: 'center'
  }
});
var ArrayItem = /*#__PURE__*/(0, _react.memo)(function (_ref) {
  var fields = _ref.fields,
      fieldIndex = _ref.fieldIndex,
      name = _ref.name,
      remove = _ref.remove,
      length = _ref.length,
      minItems = _ref.minItems,
      removeLabel = _ref.removeLabel,
      RemoveButtonProps = _ref.RemoveButtonProps,
      _ref$ArrayItemGridPro = _ref.ArrayItemGridProps,
      arrayItemClassName = _ref$ArrayItemGridPro.className,
      ArrayItemGridProps = (0, _objectWithoutProperties2["default"])(_ref$ArrayItemGridPro, _excluded),
      ArrayItemFieldsGridProps = _ref.ArrayItemFieldsGridProps;

  var _useFormApi = (0, _useFormApi2["default"])(),
      renderForm = _useFormApi.renderForm;

  var classes = useStyles();
  var editedFields = fields.map(function (field, index) {
    var computedName = field.name ? "".concat(name, ".").concat(field.name) : name;
    return _objectSpread(_objectSpread({}, field), {}, {
      name: computedName,
      key: "".concat(computedName, "-").concat(index)
    });
  });
  return /*#__PURE__*/_react["default"].createElement("div", (0, _extends2["default"])({
    className: (0, _clsx2["default"])(classes.arrayItem, arrayItemClassName)
  }, ArrayItemGridProps), /*#__PURE__*/_react["default"].createElement("div", ArrayItemFieldsGridProps, renderForm([editedFields])), /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement(_Button["default"], (0, _extends2["default"])({
    icon: "remove",
    content: removeLabel,
    basic: true,
    color: "red"
  }, RemoveButtonProps, {
    type: "button",
    onClick: function onClick() {
      return remove(fieldIndex);
    },
    disabled: length <= minItems
  }))));
}, function (_ref2, _ref3) {
  var _prevRemove = _ref2.remove,
      prev = (0, _objectWithoutProperties2["default"])(_ref2, _excluded2);
  var _nextRemove = _ref3.remove,
      next = (0, _objectWithoutProperties2["default"])(_ref3, _excluded3);
  return (0, _isEqual["default"])(prev, next);
});
ArrayItem.propTypes = {
  name: _propTypes["default"].string,
  fieldIndex: _propTypes["default"].number.isRequired,
  fields: _propTypes["default"].arrayOf(_propTypes["default"].object),
  remove: _propTypes["default"].func.isRequired,
  length: _propTypes["default"].number,
  minItems: _propTypes["default"].number,
  removeLabel: _propTypes["default"].node.isRequired,
  RemoveButtonProps: _propTypes["default"].object,
  ArrayItemGridProps: _propTypes["default"].object,
  ArrayItemFieldsGridProps: _propTypes["default"].object
};
ArrayItem.defaultProps = {
  RemoveButtonProps: {},
  ArrayItemGridProps: {},
  ArrayItemFieldsGridProps: {}
};
var defaultButtonLabels = {
  add: 'ADD',
  remove: 'REMOVE'
};
var initialState = {
  index: 0,
  history: []
};

var reducer = function reducer(state, _ref4) {
  var type = _ref4.type,
      action = _ref4.action;

  switch (type) {
    case 'redo':
      return _objectSpread(_objectSpread({}, state), {}, {
        index: state.index + 1
      });

    case 'action':
      return {
        index: state.index + 1,
        history: [].concat((0, _toConsumableArray2["default"])(state.history.slice(0, state.index)), [action])
      };

    case 'undo':
      return _objectSpread(_objectSpread({}, state), {}, {
        index: state.index - 1
      });

    case 'resetHistory':
      return _objectSpread(_objectSpread({}, state), {}, {
        history: state.history.slice(0, state.index)
      });

    default:
      return state;
  }
};

exports.reducer = reducer;

var DynamicArray = function DynamicArray(_ref5) {
  var props = (0, _extends2["default"])({}, _ref5);

  var _useFieldApi = (0, _useFieldApi2["default"])(props),
      arrayValidator = _useFieldApi.arrayValidator,
      label = _useFieldApi.label,
      description = _useFieldApi.description,
      formFields = _useFieldApi.fields,
      defaultItem = _useFieldApi.defaultItem,
      meta = _useFieldApi.meta,
      minItems = _useFieldApi.minItems,
      maxItems = _useFieldApi.maxItems,
      noItemsMessage = _useFieldApi.noItemsMessage,
      buttonLabels = _useFieldApi.buttonLabels,
      FieldArrayGridProps = _useFieldApi.FieldArrayGridProps,
      _useFieldApi$FieldArr = _useFieldApi.FieldArrayHeaderProps,
      arrayHeaderClassName = _useFieldApi$FieldArr.className,
      FieldArrayHeaderProps = (0, _objectWithoutProperties2["default"])(_useFieldApi$FieldArr, _excluded4),
      _useFieldApi$FieldArr2 = _useFieldApi.FieldArrayButtonGridProps,
      arrayButtonGridClassName = _useFieldApi$FieldArr2.className,
      FieldArrayButtonGridProps = (0, _objectWithoutProperties2["default"])(_useFieldApi$FieldArr2, _excluded5),
      ButtonGroupProps = _useFieldApi.ButtonGroupProps,
      UndoButtonProps = _useFieldApi.UndoButtonProps,
      RedoButtonProps = _useFieldApi.RedoButtonProps,
      AddButtonProps = _useFieldApi.AddButtonProps,
      _useFieldApi$Descript = _useFieldApi.DescriptionProps,
      descriptionClassName = _useFieldApi$Descript.className,
      DescriptionProps = (0, _objectWithoutProperties2["default"])(_useFieldApi$Descript, _excluded6),
      _useFieldApi$ArrayIte = _useFieldApi.ArrayItemsGridProps,
      arrayItemsClassName = _useFieldApi$ArrayIte.className,
      ArrayItemsGridProps = (0, _objectWithoutProperties2["default"])(_useFieldApi$ArrayIte, _excluded7),
      _useFieldApi$NoItemsP = _useFieldApi.NoItemsProps,
      noItemsClassname = _useFieldApi$NoItemsP.className,
      NoItemsProps = (0, _objectWithoutProperties2["default"])(_useFieldApi$NoItemsP, _excluded8),
      RemoveButtonProps = _useFieldApi.RemoveButtonProps,
      ArrayItemGridProps = _useFieldApi.ArrayItemGridProps,
      ArrayItemFieldsGridProps = _useFieldApi.ArrayItemFieldsGridProps,
      rest = (0, _objectWithoutProperties2["default"])(_useFieldApi, _excluded9);

  var _useReducer = (0, _react.useReducer)(reducer, initialState),
      _useReducer2 = (0, _slicedToArray2["default"])(_useReducer, 2),
      state = _useReducer2[0],
      dispatch = _useReducer2[1];

  var classes = useStyles();

  var combinedButtonLabels = _objectSpread(_objectSpread({}, defaultButtonLabels), buttonLabels);

  var dirty = meta.dirty,
      submitFailed = meta.submitFailed,
      error = meta.error,
      submitError = meta.submitError;
  var isError = (dirty || submitFailed) && error && typeof error === 'string';
  return /*#__PURE__*/_react["default"].createElement(_fieldArray["default"], {
    key: rest.input.name,
    name: rest.input.name,
    validate: arrayValidator
  }, function (_ref6) {
    var _ref6$fields = _ref6.fields,
        map = _ref6$fields.map,
        _ref6$fields$value = _ref6$fields.value,
        value = _ref6$fields$value === void 0 ? [] : _ref6$fields$value,
        push = _ref6$fields.push,
        remove = _ref6$fields.remove;

    var pushWrapper = function pushWrapper() {
      dispatch({
        type: 'resetHistory'
      });
      push(defaultItem);
    };

    var removeWrapper = function removeWrapper(index) {
      dispatch({
        type: 'action',
        action: {
          action: 'remove',
          value: value[index]
        }
      });
      remove(index);
    };

    var undo = function undo() {
      push(state.history[state.index - 1].value);
      dispatch({
        type: 'undo'
      });
    };

    var redo = function redo() {
      remove(value.length - 1);
      dispatch({
        type: 'redo'
      });
    };

    return /*#__PURE__*/_react["default"].createElement("div", FieldArrayGridProps, /*#__PURE__*/_react["default"].createElement("div", (0, _extends2["default"])({
      className: (0, _clsx2["default"])(classes.arrayHeader, arrayHeaderClassName)
    }, FieldArrayHeaderProps), label && /*#__PURE__*/_react["default"].createElement(_formField["default"], {
      className: classes.noMargin,
      error: isError && {
        content: error,
        color: 'red',
        pointing: 'left'
      },
      control: function control() {
        return /*#__PURE__*/_react["default"].createElement(_Header["default"], {
          floated: "left",
          className: (0, _clsx2["default"])(classes.noMargin, (0, _defineProperty2["default"])({}, classes.error, isError)),
          size: "large"
        }, label);
      }
    }), /*#__PURE__*/_react["default"].createElement("div", (0, _extends2["default"])({
      className: (0, _clsx2["default"])(classes.buttonGroup, arrayButtonGridClassName)
    }, FieldArrayButtonGridProps), /*#__PURE__*/_react["default"].createElement(_ButtonGroup["default"], ButtonGroupProps, /*#__PURE__*/_react["default"].createElement(_Button["default"], (0, _extends2["default"])({
      icon: "undo",
      className: "ddorg__suir__mapper__field-array-undo"
    }, UndoButtonProps, {
      type: "button",
      disabled: state.index === 0,
      onClick: undo
    })), /*#__PURE__*/_react["default"].createElement(_Button["default"], (0, _extends2["default"])({
      icon: "redo",
      className: "ddorg__suir__mapper__field-array-redo"
    }, RedoButtonProps, {
      type: "button",
      disabled: state.index === state.history.length,
      onClick: redo
    })), /*#__PURE__*/_react["default"].createElement(_Button["default"], (0, _extends2["default"])({
      content: combinedButtonLabels.add,
      icon: "add",
      color: "blue"
    }, AddButtonProps, {
      type: "button",
      onClick: pushWrapper,
      disabled: value.length >= maxItems
    }))))), description && /*#__PURE__*/_react["default"].createElement(_Header["default"], (0, _extends2["default"])({
      className: (0, _clsx2["default"])(classes.noMargin, descriptionClassName),
      sub: true
    }, DescriptionProps), description), /*#__PURE__*/_react["default"].createElement("div", (0, _extends2["default"])({
      className: (0, _clsx2["default"])(classes.arrayItems, arrayItemsClassName)
    }, ArrayItemsGridProps), value.length <= 0 ? /*#__PURE__*/_react["default"].createElement("p", (0, _extends2["default"])({
      className: (0, _clsx2["default"])(classes.noItems, noItemsClassname)
    }, NoItemsProps), noItemsMessage) : map(function (name, index) {
      return /*#__PURE__*/_react["default"].createElement(ArrayItem, {
        removeLabel: combinedButtonLabels.remove,
        fieldIndex: index,
        fields: formFields,
        key: name,
        name: name,
        length: value.length,
        minItems: minItems,
        remove: removeWrapper,
        RemoveButtonProps: RemoveButtonProps,
        ArrayItemGridProps: ArrayItemGridProps,
        ArrayItemFieldsGridProps: ArrayItemFieldsGridProps
      });
    })), (isError || submitError) && /*#__PURE__*/_react["default"].createElement("div", {
      className: "ddorg__suir__mapper__field-array-error"
    }, /*#__PURE__*/_react["default"].createElement("p", null, error || submitError)));
  });
};

DynamicArray.propTypes = {
  label: _propTypes["default"].node,
  description: _propTypes["default"].node,
  fields: _propTypes["default"].arrayOf(_propTypes["default"].object).isRequired,
  defaultItem: _propTypes["default"].any,
  minItems: _propTypes["default"].number,
  maxItems: _propTypes["default"].number,
  noItemsMessage: _propTypes["default"].node,
  buttonLabels: _propTypes["default"].object,

  /** Sub components customization API */
  FieldArrayGridProps: _propTypes["default"].object,
  FieldArrayHeaderProps: _propTypes["default"].object,
  FieldArrayButtonGridProps: _propTypes["default"].object,
  ButtonGroupProps: _propTypes["default"].object,
  UndoButtonProps: _propTypes["default"].object,
  RedoButtonProps: _propTypes["default"].object,
  AddButtonProps: _propTypes["default"].object,
  DescriptionProps: _propTypes["default"].object,
  ArrayItemsGridProps: _propTypes["default"].object,
  NoItemsProps: _propTypes["default"].object,
  RemoveButtonProps: _propTypes["default"].object,
  ArrayItemGridProps: _propTypes["default"].object,
  ArrayItemFieldsGridProps: _propTypes["default"].object
};
DynamicArray.defaultProps = {
  maxItems: Infinity,
  minItems: 0,
  noItemsMessage: 'No items added',
  FieldArrayGridProps: {},
  FieldArrayHeaderProps: {},
  FieldArrayButtonGridProps: {},
  ButtonGroupProps: {},
  UndoButtonProps: {},
  RedoButtonProps: {},
  AddButtonProps: {},
  DescriptionProps: {},
  ArrayItemsGridProps: {},
  NoItemsProps: {},
  RemoveButtonProps: {},
  ArrayItemGridProps: {},
  ArrayItemFieldsGridProps: {}
};
var _default = DynamicArray;
exports["default"] = _default;